#ifndef	__RKIO_H__
#define	__RKIO_H__


#ifdef _DEBUG
#define DEBUG(format, args...) printf("[%s:%d] "format, __FILE__, __LINE__, ##args)
#else
#define DEBUG(args...)
#endif


#define	MAX_PIN_NUM		      (0x40) 
#define CENTERPWM	0x01
//asuspi gpio
//asus
#define SERIAL       40
#define SPI          41
#define I2C          42
#define PWM          43
#define GPIO		 44
#define TS_XXXX		 45
#define RESERVED	 46
#define I2S		 47
#define GPS_MAG		 48
#define HSADCT		 49
#define USB		 50
#define HDMI		 51
#define SC_XXX		 52
#define GPIOIN		 53
#define GPIOOUT		 54
#define CLKOUT		 55
#define CLK1_27M	 56
#define VOP0_PWM	 57
#define VOP1_PWM	 58
#define PMU_DEBUG	 59
#define PMUM0_JTAG	 60
#define VOP		 61
#define VOP_DATA	 62
#define VOP_DCLK	 63
#define CIF		 64
#define CIF_DATA	 65
#define CIF_VSYNC	 66
#define CIF_HREF	 67
#define CIF_CLKIN	 68
#define SDIO		 69
#define A53_WFI		 70
#define A72_WFI		 71
#define TRACE_DATA	 72
#define SPDIF		 73
#define SDMMC_WRPRT	 74
#define PMUM0_WFI	 75

// Port function select bits

#define	FSEL_INPT		0b000
#define	FSEL_OUTP		0b001
#define	FSEL_ALT0		0b100
#define	FSEL_ALT1		0b101
#define	FSEL_ALT2		0b110
#define	FSEL_ALT3		0b111
#define	FSEL_ALT4		0b011
#define	FSEL_ALT5		0b010

#define GPIO_BANK	5

#define RK3399PRO_GPIO0_A6		(0+6)
#define RK3399PRO_GPIO0_B0		(0+8)

#define RK3399PRO_GPIO1_A7		(8+31)
#define RK3399PRO_GPIO1_B0		(9+31)
#define RK3399PRO_GPIO1_B1		(10+31)
#define RK3399PRO_GPIO1_B2		(11+31)

#define RK3399PRO_GPIO2_A7		(8+63)
#define RK3399PRO_GPIO2_B0		(9+63)
#define RK3399PRO_GPIO2_B1		(10+63)
#define RK3399PRO_GPIO2_B2		(11+63)

#define RK3399PRO_GPIO2_C0		(17+63)
#define RK3399PRO_GPIO2_C1		(18+63)
#define RK3399PRO_GPIO2_C2		(19+63)
#define RK3399PRO_GPIO2_C3		(20+63)
#define RK3399PRO_GPIO2_C4		(21+63)
#define RK3399PRO_GPIO2_C5		(22+63)
#define RK3399PRO_GPIO2_C6		(23+63)
#define RK3399PRO_GPIO2_C7		(24+63)
#define RK3399PRO_GPIO2_D1              (26+63)

#define RK3399PRO_GPIO3_D0		(25+95)
#define RK3399PRO_GPIO3_D1		(26+95)
#define RK3399PRO_GPIO3_D2		(27+95)
#define RK3399PRO_GPIO3_D3		(28+95)
#define RK3399PRO_GPIO3_D4		(29+95)
#define RK3399PRO_GPIO3_D5		(30+95)
#define RK3399PRO_GPIO3_D6		(31+95)
#define RK3399PRO_GPIO3_D7		(32+95)


#define RK3399PRO_GPIO4_C2		(19+127)
#define RK3399PRO_GPIO4_C5		(22+127)
#define RK3399PRO_GPIO4_C6		(23+127)

#define RK3399PRO_PMU		0xff310000
#define RK3399PRO_PMUGRF	0xff320000
#define RK3399PRO_GRF		0xff770000
#define RK3399PRO_CRU		0xff760000
#define RK3399PRO_PMUCRU	0xff750000

#define RK3399PRO_GPIO		0xff720000, \
				0xff730000, \
				0xff780000, \
				0xff788000, \
				0xff790000, \


//#define RK3399PRO_GPIO[] {0xff720000, 0xff730000,0xff780000,0xff788000,0xff790000}


#define RK3399PRO_PMUGRF_GPIO0A_IOMUX		0x00000
#define RK3399PRO_PMUGRF_GPIO0B_IOMUX		0x00004
#define RK3399PRO_PMUGRF_GPIO1A_IOMUX		0x00010
#define RK3399PRO_PMUGRF_GPIO1B_IOMUX		0x00014
#define RK3399PRO_GRF_GPIO2A_IOMUX		0x0e000
#define RK3399PRO_GRF_GPIO2B_IOMUX		0x0e004
#define RK3399PRO_GRF_GPIO2C_IOMUX		0x0e008
#define RK3399PRO_GRF_GPIO2D_IOMUX		0x0e00c
#define RK3399PRO_GRF_GPIO3D_IOMUX		0x0e01c
#define RK3399PRO_GRF_GPIO4C_IOMUX		0x0e028

/* Pull up / down / Z */
#define RK3399PRO_PMUGRF_GPIO0A_P		0x00040
#define RK3399PRO_PMUGRF_GPIO0B_P		0x00044
#define RK3399PRO_PMUGRF_GPIO1A_P		0x00050
#define RK3399PRO_PMUGRF_GPIO1B_P		0x00054
#define RK3399PRO_GRF_GPIO2A_P			0x0e040
#define RK3399PRO_GRF_GPIO2B_P			0x0e044
#define RK3399PRO_GRF_GPIO2C_P			0x0e048
#define RK3399PRO_GRF_GPIO2D_P			0x0e04c
#define RK3399PRO_GRF_GPIO3D_P			0x0e05c
#define RK3399PRO_GRF_GPIO4C_P			0x0e068

/* Drive Strength */
#define RK3399PRO_PMUGRF_GPIO0A_E		0x00080
#define RK3399PRO_PMUGRF_GPIO0B_E		0x00088
#define RK3399PRO_PMUGRF_GPIO1A_E		0x000a0
#define RK3399PRO_PMUGRF_GPIO1B_E		0x000a8
#define RK3399PRO_GRF_GPIO2A_E			0x0e100
#define RK3399PRO_GRF_GPIO2B_E			0x0e104
#define RK3399PRO_GRF_GPIO2C_E			0x0e108
#define RK3399PRO_GRF_GPIO2D_E			0x0e10c
#define RK3399PRO_GRF_GPIO3D_E			0x0e128
#define RK3399PRO_GRF_GPIO4C_E			0x0e138


#define RK3399PRO_PWM			0xff420000
#define RK3399PRO_PWM0_CNT		0x0000
#define RK3399PRO_PWM0_PERIOD_HPR	0x0004
#define RK3399PRO_PWM0_DUTY_LPR		0x0008
#define RK3399PRO_PWM0_CTRL		0x000c

#define RK3399PRO_PWM1_CNT		0x0010
#define RK3399PRO_PWM1_PERIOD_HPR	0x0014
#define RK3399PRO_PWM1_DUTY_LPR		0x0018
#define RK3399PRO_PWM1_CTRL		0x001c

#define RK3399PRO_PWM3_CNT		0x0030
#define RK3399PRO_PWM3_PERIOD_HPR	0x0034
#define RK3399PRO_PWM3_DUTY_LPR		0x0038
#define RK3399PRO_PWM3_CTRL		0x003c

#define RK3399PRO_GPIO_SWPORTA_DR_OFFSET	0x0000
#define RK3399PRO_GPIO_SWPORTA_DDR_OFFSET	0x0004
#define RK3399PRO_GPIO_INTEN_OFFSET		0x0030
#define RK3399PRO_GPIO_INTMASK_OFFSET		0x0034
#define RK3399PRO_GPIO_INTTYPE_LEVEL_OFFSET	0x0038
#define RK3399PRO_GPIO_INT_POLARITY_OFFSET	0x003c
#define RK3399PRO_GPIO_INT_STATUS_OFFSET	0x0040
#define RK3399PRO_GPIO_INT_RAWSTATUS_OFFSET	0x0044
#define RK3399PRO_GPIO_DEBOUNCE_OFFSET		0x0048
#define RK3399PRO_GPIO_PORTA_EOI_OFFSET		0x004c
#define RK3399PRO_GPIO_EXT_PORTA_OFFSET		0x0050
#define RK3399PRO_GPIO_LS_SYNC_OFFSET		0x0060

#define RK3399PRO_PWM0	RK3399PRO_GPIO4_C2
#define RK3399PRO_PWM1	RK3399PRO_GPIO4_C6
#define RK3399PRO_PWM3  RK3399PRO_GPIO0_A6

#define RK3399PRO_CRU_CLKSEL_CON27		0x016c
#define RK3399PRO_CRU_CLKSEL_CON38		0x0198
#define RK3399PRO_PMUCRU_CLKGATE_CON1		0x0104
#define RK3399PRO_CRU_CLKGATE_CON31		0x037c
#define RK3399PRO_CRU_CLKGATE_CON13		0x0334

#endif
